
// ODBConsole.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#include "afxwinappex.h"
#include "afxdialogex.h"
#include "AKAssms.h"
#include "MainFrm.h"

#include "ChildFrm.h"
#include "MDIChildExecute.h"
#include "AKAssmsDoc.h"
#include "AKAssmsView.h"
#include "AKAssmsViewEditSQL.h"
#include "AKAssmsListView.h"

#include "CWndApp_Ext.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAKAssmsApp

// CAKAssmsApp construction

CAKAssmsApp::CAKAssmsApp()
{
    m_bHiColorIcons = TRUE;
    m_pP2PmsgMgr    = 0;
    m_pP2Pconfig    = 0;

	// support Restart Manager
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_ALL_ASPECTS;
#ifdef _MANAGED
	// If the application is built using Common Language Runtime support (/clr):
	//     1) This additional setting is needed for Restart Manager support to work properly.
	//     2) In your project, you must add a reference to System.Windows.Forms in order to build.
	System::Windows::Forms::Application::SetUnhandledExceptionMode(System::Windows::Forms::UnhandledExceptionMode::ThrowException);
#endif

	// TODO: replace application ID string below with unique ID string; recommended
	// format for string is CompanyName.ProductName.SubProduct.VersionInformation
	SetAppID(_T("AKAssms.AppID.NoVersion"));

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CAKAssmsApp object

CAKAssmsApp theApp;


// CAKAssmsApp initialization

BOOL CAKAssmsApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinAppEx::InitInstance();

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	EnableTaskbarInteraction();

	// AfxInitRichEdit2() is required to use RichEdit control	
	// AfxInitRichEdit2();

    // Mandatories
    // NOTES: Required to support the P2PmsgHub's and pump's()
    if ( StartupP2Pmsg() )
      ThrowP2Pevent();
    P2Pevent::Service("AKAssms"); 
    WSADATA oWsaData;
    WORD    wVersionRequested = MAKEWORD( 2, 0 );
    if ( WSAStartup ( wVersionRequested, &oWsaData ) )
      EVERR->MODULE
           ->Message_T("WSAStartup() failed" ) 
           ->HResult  ( WSAGetLastError() )->Throw();


	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)


	InitContextMenuManager();

	InitKeyboardManager();

	InitTooltipManager();
	CMFCToolTipInfo ttParams;
	ttParams.m_bVislManagerTheme = TRUE;
	theApp.GetTooltipManager()->SetTooltipParams(AFX_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS(CMFCToolTipCtrl), &ttParams);

    // Register the application's document templates.  Document templates
	  //  serve as the connection between documents, frame windows and views
	  //CMultiDocTemplate* pDocTemplate;
	  m_pDocTemplate
      = new CMultiDocTemplate ( IDR_ODBConsoleTYPE,
		                            RUNTIME_CLASS(CAKAssmsDoc),
		                            RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		                            RUNTIME_CLASS(CAKAssmsView));
	  if (!m_pDocTemplate)
		  return FALSE;
	  AddDocTemplate(m_pDocTemplate);

    m_pDocTemplateExecute
      = new CMultiDocTemplate ( IDR_ODBConsoleTYPE,
                                RUNTIME_CLASS(CAKAssmsDoc),
                                RUNTIME_CLASS(CMDIChildExecute), // custom SQL Execute child frame
                                RUNTIME_CLASS(CAKAssmsViewEditSQL) );
    if ( !m_pDocTemplateExecute )
      return FALSE;
    AddDocTemplate(m_pDocTemplateExecute);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame || !pMainFrame->LoadFrame(IDR_MAINFRAME))
	{
		delete pMainFrame;
		return FALSE;
	}
	m_pMainWnd = pMainFrame;
	// call DragAcceptFiles only if there's a suffix
	//  In an MDI app, this should occur immediately after setting m_pMainWnd
	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	  // Parse command line for standard shell commands, DDE, file open
    // NOTES: Negate new file creation on startup
	  CCommandLineInfo cmdInfo;
	  ParseCommandLine(cmdInfo);
    if ( cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew )
      cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;

	  // Enable DDE Execute open
	  EnableShellOpen();
	  RegisterShellFileTypes(TRUE);

    // Dispatch commands specified on the command line.  Will return FALSE if
    // app was launched with /RegServer, /Register, /Unregserver or /Unregister.
    if ( !ProcessShellCommand(cmdInfo) )
    	return FALSE;
    // The main window has been initialized, so show and update it
    pMainFrame -> ShowWindow(m_nCmdShow);
    pMainFrame -> UpdateWindow();

    // Workspace data repository
    m_pP2PmsgMgr = new P2PmsgMgr ( );
    GetP2Pconfig ();
	  return TRUE;
}

int
CAKAssmsApp::ExitInstance ( )
{
	  //TODO: handle additional resources you may have added
	  AfxOleTerm(FALSE);

    // Resource recovery
    if ( m_pP2Pconfig )
      m_pP2Pconfig -> Save ( );
    //if ( m_pP2Pconfig )
    //  m_pP2Pconfig -> Print ( stdout, 1);

    delete m_pP2Pconfig;
           m_pP2Pconfig = 0;
    delete m_pP2PmsgMgr;
           m_pP2PmsgMgr = 0;
    CleanupP2Pmsg ( );

    // Delegate for rest
    return CWinAppEx::ExitInstance();
}

// CAKAssmsApp message handlers


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// App command to run the dialog
void CAKAssmsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CAKAssmsApp customization load/save methods

void CAKAssmsApp::PreLoadState()
{
	BOOL bNameValid;
	CString strName;
	bNameValid = strName.LoadString(IDS_EDIT_MENU);
	ASSERT(bNameValid);
	GetContextMenuManager()->AddMenu(strName, IDR_POPUP_EDIT);
	bNameValid = strName.LoadString(IDS_EXPLORER);
	ASSERT(bNameValid);
	GetContextMenuManager()->AddMenu(strName, IDR_POPUP_EXPLORER);
}

void CAKAssmsApp::LoadCustomState()
{
}

void CAKAssmsApp::SaveCustomState()
{
}

P2PmsgMgr*
CAKAssmsApp::GetP2PmsgMgr ( )
{
   return m_pP2PmsgMgr;
}
P2PmsgMgr*
CAKAssmsApp::GetP2Pconfig ( )
{
    // Only if requested
    if ( m_pP2Pconfig )
      return m_pP2Pconfig;

    // Build application AKAssms.P2Pconfig file path
    CString strLocalAppDataFile
      = CWinApp_LocalAppDataFilePath ( _T("AKAssma.P2Pconfig") );

    // Instanciate application AKAssms.P2Pconfig file
    if ( PathFileExists(strLocalAppDataFile)    &&
         P2PmsgMgr_IsValid(strLocalAppDataFile)     )
      m_pP2Pconfig = P2PmsgMgr::Factory ( strLocalAppDataFile );
    else if ( DeleteFile(strLocalAppDataFile)        ||
              GetLastError() == ERROR_FILE_NOT_FOUND    )
      m_pP2Pconfig = P2PmsgMgr::Factory ( strLocalAppDataFile, VBLock_Addr32, 2024, 0 );  
    return m_pP2Pconfig;
}

CAKAssmsHub*
CAKAssmsApp::GetAKAssmsHub ( )
{
   return dynamic_cast<CAKAssmsHub*>(m_pMainWnd);
}
///////////////////////////////////////////////////////////////////////////////
//  CAKAssmsApp message map and handlers

BEGIN_MESSAGE_MAP(CAKAssmsApp, CWinAppEx)
    // External commands
    ON_THREAD_MESSAGE(WM_APP_TABLE_TOP_1000_ROWS,OnTableSelectTop1000Rows)
    ON_THREAD_MESSAGE(WM_APP_VIEW_TOP_1000_ROWS,OnViewSelectTop1000Rows)

	  ON_COMMAND(ID_APP_ABOUT, &CAKAssmsApp::OnAppAbout)
	  // Standard file based document commands
	  ON_COMMAND(ID_FILE_NEW, &CWinAppEx::OnFileNew)
	  ON_COMMAND(ID_FILE_OPEN, &CWinAppEx::OnFileOpen)
	  // Standard print setup command
	  ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinAppEx::OnFilePrintSetup)
END_MESSAGE_MAP()

//
//  WM_APP_TABLE_TOP_1000_ROWS handler
//  NOTES: New documents usually instigated from theApp
//
//  Parameters:  WPARAM wParam
//               Position of table node to be queried in m_pP2PmsgMgr
//
//               LPARAM lParam
//               Spare
void
CAKAssmsApp::OnTableSelectTop1000Rows ( WPARAM wParam, LPARAM lParam )
{
    // Create document view for SQL query
    CDocument *pDoc = m_pDocTemplateExecute -> OpenDocumentFile ( NULL );
    if ( pDoc == nullptr )
      return;
    CAKAssmsDoc *pAKAssmsDoc = dynamic_cast<CAKAssmsDoc*>(pDoc);
    if ( pAKAssmsDoc == nullptr )
      return;

    // Delegate
    pAKAssmsDoc -> DoTableSelectTop1000Rows ( wParam, lParam );
    return;
}

//
//  WM_APP_VIEW_TOP_1000_ROWS handler
//  NOTES: New documents usually instigated from theApp
//
//  Parameters:  WPARAM wParam
//               Position of table node to be queried in m_pP2PmsgMgr
//
//               LPARAM lParam
//               Spare
void
CAKAssmsApp::OnViewSelectTop1000Rows ( WPARAM wParam, LPARAM lParam )
{
    // Create document view for SQL query
    CDocument *pDoc = m_pDocTemplateExecute -> OpenDocumentFile ( NULL );
    if ( pDoc == nullptr )
      return;
    CAKAssmsDoc *pAKAssmsDoc = dynamic_cast<CAKAssmsDoc*>(pDoc);
    if ( pAKAssmsDoc == nullptr )
      return;

    // Delegate
    pAKAssmsDoc -> DoViewSelectTop1000Rows ( wParam, lParam );
    return;
}
